#ifndef _DIS_REQUEST_H_
#define _DIS_REQUEST_H_

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#include "dis.h"
#include "disauth.h"
#include "discommon.h"
#include "curl/curl.h"
#include "apr_ring.h"




#define MAX_HEAD_SIZE           128

#define DIS_REQ_BASE_SIZE       4096

#define DIS_RSP_BASE_SIZE       4096

#define MAX_URI_SIZE       (BASE_URL_LEN + MAX_PROJECTID_LEN + MAX_STREAMNAME_LEN)
#define MAX_QUERY_PARAM  10



typedef struct _DisRequest
{
    char  *FreeMemPtr;
    int    MaxSize;
    int    CurrentSize;

    DISStatus status;
    DISInterfaceType msgType;

    void *inputData;

    int   RspBodyCalLen;
    int   RspBodyCurrentLen;
    char *RspBody;
    void *jsonData;

    int httpResponseCode;
    struct curl_slist *headers;
    CommonRequest request;
} DisRequest;

char *DisGetMethodByMsgType(DISInterfaceType requestType);

DISStatus DisAddQueryList(DisRequest *req, char *QueryName, char *QueryValue);

DISStatus DisValidateDisString(const char *string, int len, int maxLen) ;

DISStatus DisComposeUri(DisRequest *request, DISContext *context, char *externData);

DISStatus DisGetRequest(DisRequest **request, DISInterfaceType msgType, DISContext *context, int bodyLen);

int DisCalculateRequestSize(DISInterfaceType requestType, int additionalSize);

void DisReleaseRequest(DisRequest *request);

void * DisRequestAlloc(DisRequest *disRequest, int size);

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#endif /* _DIS_REQUEST_H_ */