#include "string.h"
#include "stdio.h"
#include "time.h"
#include "ctype.h"
#include "log.h"
#include "discommon.h"
#include "disauth.h"
#include "util.h"
#include "disosadapt.h"



int strToLower(char *srcStr, char *dstStr)
{
	unsigned int len = 0;

	printfdbgfunc;
	for(len = 0; len < strlen(srcStr); len++)
	{
		dstStr[len] = tolower(srcStr[len]);
	}

	printfdbgoutfunc;
	return 0;
}


int getSpecifyKey(CommonList  *pstKeyValueList, char *baseKey, CommonKeyValue **pKeyValue)
{
	CommonKeyValue *pTemp = (CommonKeyValue *)pstKeyValueList->pItem;
	CommonKeyValue *pSpecifyTemp = NULL;
	char *tempBase = baseKey;
	int loop = 0;

	printfdbgfunc;

	if(1 == pstKeyValueList->itemCount)
	{
		if(NULL == tempBase)
		{
			*pKeyValue = pstKeyValueList->pItem;
			return 0;
		}
		else
		{
			*pKeyValue = NULL;
			return 0;
		}
	}

	for(loop = 0; (loop < pstKeyValueList->itemCount) && (NULL != pTemp); loop++, pTemp=pTemp->next)
	{
		if(NULL != tempBase)
		{
			if(strcmp((pTemp->KeyName), tempBase) > 0)
			{
				if(NULL == pSpecifyTemp)
				{
					pSpecifyTemp = pTemp;
				}
				else
				{
					if(strcmp((pTemp->KeyName), pSpecifyTemp->KeyName) < 0)
					{
						pSpecifyTemp = pTemp;
					}
				}
			}
			else
			{
				continue;
			}
		}
		else
		{
			if(NULL == pSpecifyTemp)
			{
				pSpecifyTemp = pTemp;
			}
			else
			{
				if(strcmp((pTemp->KeyName), pSpecifyTemp->KeyName) < 0)
				{
					pSpecifyTemp = pTemp;
				}
			}
		}
	}

	*pKeyValue = pSpecifyTemp;

	printfdbgoutfunc;
	return 0;
}



int insertItemSortByKey(CommonList *pstKeyValueList, CommonKeyValue *pKeyValueItem, int toLowerFlag)
{
	int loop = 0;
	int iRet = 0;
	CommonKeyValue *pTemp = NULL, *pLastItem = NULL;

	printfdbgfunc;

	if(0 != toLowerFlag)
	{
		strToLower(pKeyValueItem->KeyName, pKeyValueItem->KeyName);
	}

	if(0 == pstKeyValueList->itemCount)
	{
		pstKeyValueList->pItem = (void *)pKeyValueItem;
		pstKeyValueList->itemCount++;
		return 0;
	}

	pTemp = (CommonKeyValue *)pstKeyValueList->pItem;
	pLastItem = NULL;
	for(loop = 0; loop < pstKeyValueList->itemCount && pTemp != NULL; loop++, pTemp = pTemp->next)
	{
		iRet = strcmp(pKeyValueItem->KeyName, pTemp->KeyName);
		if(iRet < 0)
		{
			break;
		}
		else
		{
			if(iRet > 0)
			{
				pLastItem = pTemp;
			}
			else
			{
				return -1;
			}
		}
	}

	if(NULL == pLastItem)
	{
		pKeyValueItem->next = pTemp;
		pstKeyValueList->pItem = (void *)pKeyValueItem;
	}
	else
	{
		pLastItem->next = pKeyValueItem;
		pKeyValueItem->next = pTemp;
	}

	pstKeyValueList->itemCount++;

	printfdbgoutfunc;
	return 0;

}

#if 0
int sort_keyvalue(char *buffer, int *currentUseLen, int maxLen, CommonList *pstKeyValueList, char connectorChar, char jionChar)
{
	int len = 0, remainLen, iRet = 0, stringlen;
	CommonKeyValue *pTempKeyValue = NULL;
	char *pBaseKey = NULL;
	int loop = 0;

	char *rawString = *buffer;	

	len = *currentUseLen;

	printfdbgfunc;

	if(NULL == pstKeyValueList || 0 == pstKeyValueList->itemCount)
	{
		return 0;
	}

	for(loop = 0; loop < pstKeyValueList->itemCount; loop++)
	{
		pBaseKey = (pTempKeyValue == NULL) ? NULL : pTempKeyValue->KeyName;
		pTempKeyValue = NULL;

		iRet = getSpecifyKey(pstKeyValueList, pBaseKey, &pTempKeyValue);
		if(iRet != 0)
		{
			return 1;
		}

		if(NULL == pTempKeyValue)
		{
			break;
		}

		if(pBaseKey != NULL)
		{
			STRING_APPEND(buffer, len, maxLen,"%c",jionChar);
		}

		STRING_APPEND(buffer, len, maxLen, "%s%c%s", pTempKeyValue->KeyName, connectorChar, pTempKeyValue->valueContent);

		if(remainLen <= 0)
		{
			return -1;
		}

	}

	*currentUseLen = len;

	return 0;

}
#endif

void DisAuthDbgInfo(const CommonRequest *req)
{
	int loop = 0;
	CommonKeyValue *pTemp;

	printfdbgfunc;
	printf("the http method: %s\n", req->method);
	printf("the header count:%d\r\n", req->httpHeaderList.itemCount);
	pTemp = (CommonKeyValue *)(req->httpHeaderList.pItem);
	for(loop = 0; loop < req->httpHeaderList.itemCount; loop++)
	{		
		printf("this header is %s:%s\n", pTemp->KeyName, pTemp->valueContent);
		pTemp = pTemp->next;
	}

	printf("the querylist count:%d\r\n", req->queryParamList.itemCount);
	pTemp = (CommonKeyValue *)(req->queryParamList.pItem);
	for(loop = 0; loop < req->queryParamList.itemCount; loop++)
	{		
		printf("this header is %s:%s\n", pTemp->KeyName, pTemp->valueContent);
		pTemp = pTemp->next;
	}

	printf("the uri: %s\n", req->uri);
	if(NULL != req->body)
		printf("the body: %s\n", req->body);
	printf("the auth: %s\n", req->authString);
	printfdbgoutfunc;
}

int compose_auth_header(const CommonRequest *params, char *ak, char *sk, char *region, char *serviceName)
{

	char canonicalRequest[4096] = {0};

	int loop = 0;
	char hashedPayload[65] = {0};
	char temp[32] = {0};
	char Hexreq[65] = {0};
	char stringToSign[1024] = {0};
    char date[64] = {0};
	char datime[64]= {0};
	char signedHeader[128] = {0};
	int signedHeaderLen = 0;
	char* pInputContent = NULL;

	char temp_key[256] = {0};
	unsigned char dateKey[32] = {0};
	unsigned char dateRegionKey[32] = {0};
	unsigned char dateRegionServicekey[32] = {0};
	unsigned char signingKey[32] = {0};
	unsigned char signature_hmac[32] = {0};
	unsigned char signature[64+8] = {0};
    /*DIS modify*/
	//unsigned char service[8];
	char *req = "sdk_request";

	//char *signedHeaders = "content-type;host;x-sdk-date";

	char Hexreq1[65] = {0}; 
	char Hexreq2[65] = {0};  
	char Hexreq3[65] = {0}; 
	char Hexreq4[65] = {0};

	CommonKeyValue *pTempKV=NULL;

	//int  remainLen = 4096;
	int len = 0;
	//char *pReq = (char*)canonicalRequest;


	printfdbgfunc;

	STRING_APPEND(canonicalRequest, len, 4096, "%s\n", (params->method));
	STRING_APPEND(canonicalRequest, len, 4096, "%s\n", (params->uri));

	for(loop = 0, pTempKV = (CommonKeyValue *)params->queryParamList.pItem; loop < params->queryParamList.itemCount && NULL != pTempKV; loop++, pTempKV=pTempKV->next)
	{
		if(loop != 0)
		{
			STRING_APPEND(canonicalRequest, len, 4096, "%c", '&');
		}
		STRING_APPEND(canonicalRequest, len, 4096, "%s", pTempKV->valueContent);
	}
	STRING_APPEND(canonicalRequest, len, 4096, "%c", '\n');

	logPrint(DISLogLevelInfo,"[DISTEST]]querylist=[%s]\n",(char*)canonicalRequest);


	if(0 == params->httpHeaderList.itemCount)
	{
		return 1;
	}

	signedHeaderLen = 0;
	for(loop = 0, pTempKV = (CommonKeyValue *)params->httpHeaderList.pItem; loop < params->httpHeaderList.itemCount && NULL != pTempKV; loop++, pTempKV=pTempKV->next)
	{
		STRING_APPEND(canonicalRequest, len, 4096, "%s\n", pTempKV->valueContent);
		if(loop != 0)
		{
			STRING_APPEND(signedHeader, signedHeaderLen, 128, "%c", ';');
		}
		STRING_APPEND(signedHeader, signedHeaderLen, 128, "%s", pTempKV->KeyName);
	}
	STRING_APPEND(canonicalRequest, len, 4096, "%c", '\n');

	STRING_APPEND(canonicalRequest, len, 4096, "%s\n", signedHeader);
	

	pInputContent = (NULL == params->body)?"":params->body;

	SHA256Hash((unsigned char*)temp,(unsigned char *) pInputContent,strlen(pInputContent));	
	ustr_to_hexes((unsigned char*)temp,sizeof(temp),(unsigned char*)hashedPayload);
	logPrint(DISLogLevelInfo,"\n[DISTEST]]MsgBodyHash=[%s]\n",(char*)hashedPayload);

	//appendString(pReq, remainLen, hashedPayload, strlen(hashedPayload));
	STRING_APPEND(canonicalRequest, len, 4096, "%s", hashedPayload);

	logPrint(DISLogLevelInfo,"\n[DISTEST]]canonicalRequest=[%s]\n",(char*)canonicalRequest);

	SHA256Hash((unsigned char*)temp,(unsigned char *) canonicalRequest,strlen(canonicalRequest));
	ustr_to_hexes((unsigned char*)temp,sizeof(temp),(unsigned char*)Hexreq);

	len = 0;
	STRING_APPEND(stringToSign, len, 1024, "%s\n","SDK-HMAC-SHA256");

	strftime(date, sizeof(date), "%Y%m%d", gmtime(&(params->now)));
	strftime(datime, sizeof(datime), "%H%M%S", gmtime(&(params->now)));

	STRING_APPEND(stringToSign, len, 1024, "%sT%sZ\n",date,datime);
	STRING_APPEND(stringToSign, len, 1024, "%s/%s/%s/%s\n",date,region,serviceName,"sdk_request");
	STRING_APPEND(stringToSign, len, 1024, "%s",Hexreq);
	logPrint(DISLogLevelInfo,"stringtosign=%s\n",(char*)stringToSign);


	sprintf(temp_key,"SDK%s",sk);//ok
	logPrint(DISLogLevelInfo,"\n[DISTEST]kSecret = [%s]" , (char*)temp_key);
	logPrint(DISLogLevelInfo,"\n[DISTEST]date = [%s]" , (char*)date);
    /*
      kSecret = SK
      kDate = HMAC("SDK"+kSecret , Date)
    */
	
	HMAC_SHA256(dateKey,  (unsigned char*)temp_key,strlen(temp_key), (unsigned char*)date,(int)strlen(date));
	ustr_to_hexes((unsigned char*)dateKey,sizeof(dateKey),(unsigned char*)Hexreq1);
	logPrint(DISLogLevelInfo,"\n[DISTEST]kDate = [%s]" , (char*)Hexreq1);
	/*
      kRegion = HMAC(kDate , Region)
	*/
	
	HMAC_SHA256(dateRegionKey,  dateKey,sizeof(dateKey), (unsigned char*)region,(int)strlen(region));
	ustr_to_hexes((unsigned char*)dateRegionKey,sizeof(dateRegionKey),(unsigned char*)Hexreq2);
	logPrint(DISLogLevelInfo,"\n[DISTEST]kRegion = [%s]" , (char*)Hexreq2);
	/*
      kService = HMAC(kRegion , service)
	*/	
	
	HMAC_SHA256(dateRegionServicekey,  dateRegionKey,sizeof(dateRegionKey), (unsigned char*)serviceName,(int)(strlen(serviceName)));
	ustr_to_hexes((unsigned char*)dateRegionServicekey,sizeof(dateRegionServicekey),(unsigned char*)Hexreq3);
	logPrint(DISLogLevelInfo,"\n[DISTEST]kService = [%s]" , (char*)Hexreq3);
	/*
      kSigning = HMAC(kService , sdk_request)
	*/		
	
	HMAC_SHA256(signingKey,  dateRegionServicekey,sizeof(dateRegionServicekey), (unsigned char*)req,(int)strlen(req));
	ustr_to_hexes((unsigned char*)signingKey,sizeof(signingKey),(unsigned char*)Hexreq4);
	logPrint(DISLogLevelInfo,"\n[DISTEST]ksdk-request = [%s]" , (char*)Hexreq4);
	/*
      kSignature = HMAC(kSigning , stringToSign)
	*/
	//char Hexreq5[65] = {0}; 
	HMAC_SHA256(signature_hmac,  signingKey,sizeof(signingKey), (unsigned char*)stringToSign,(int)strlen(stringToSign));
	/*
      Signature = hex(kSignature)
	*/
	ustr_to_hexes(signature_hmac,sizeof(signature_hmac),signature);
	logPrint(DISLogLevelInfo,"\n[DISTEST]Signature = [%s]\n" , (char*)signature);


	sprintf(params->authString, "Authorization: SDK-HMAC-SHA256 Credential=%s/%s/%s/%s/%s, SignedHeaders=%s, Signature=%s", 
			 ak,
             date,
             region,
             serviceName,
			 "sdk_request",
			 signedHeader,
			 (const char*)signature);
    logPrint(DISLogLevelInfo,"%s\n",(char*)(params->authString));    

#ifdef DIS_DEBUG
	DisAuthDbgInfo(params);
#endif

	printfdbgoutfunc;
    return 0;	
}


