#ifndef _DIS_AUTH_H_
#define _DIS_AUTH_H_

#include <time.h>
#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cpluscplus */
#endif /* __cpluscplus */

typedef enum 
{
	KeyTypeHeader = 0,
	KeyTypeQueryParam,
	KeyTypeAll
}KeyType;

typedef struct _CommonKeyValue
{
	char   KeyName[32];
	char  *valueContent;
	struct _CommonKeyValue *next;
}CommonKeyValue;

typedef struct _CommonList
{
	int itemCount;
	void *pItem;
}CommonList;

typedef struct _CommonRequest
{
	char   method[16];
	char  *uri;
	time_t now;
	CommonList  queryParamList;
	CommonList  httpHeaderList;
	char  *body;
	int    bodyCurrentLen;
	int    bodyMaxLen;
	char   authString[256];
}CommonRequest;
int sort_keyvalue(char *buffer, int *currentUseLen, int maxLen, CommonList *pstKeyValueList, char connectorChar, char jionChar);
int compose_auth_header(const CommonRequest *params, char *ak, char *sk, char *region, char *serviceName);
int insertItemSortByKey(CommonList *pstKeyValueList, CommonKeyValue *pKeyValueItem, int toLowerFlag);

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#endif /* _DIS_AUTH_H_ */