#include "stdio.h"
#include "dismemmgt.h"
#include "discommon.h"
#include "log.h"
#include <stdlib.h>
#include <string.h>

extern MemMgtRegion g_disMemPool = {0};

MEM_CFG g_MemCfg[] = 
    {
        {32,  10000},
        {256, 10000},
        {2048,20000},
        {40960,100},
        {1024*1024*2, 10},
        {1024*1024*10, 1}
    };

unsigned int disMemPoolInit()
{
    unsigned int ret = 0;

	printfdbgfunc;

    ret = SmCreate(&(g_disMemPool.mutex));
    if(0 != ret)
    {
        printf("create mutex error: %d\r\n", ret);
        return ret;
    }

    ret = mem_region_init(&g_disMemPool.stMemRegion, (MEM_CFG *)&g_MemCfg, (sizeof(g_MemCfg)/sizeof(MEM_CFG)), 1, 0);
    if(0 != ret)
    {
        disMemPoolDeinit();
        printf("create MemRegion error: %d\r\n", ret);
        return ret;
    }

    g_disMemPool.initFlag = MEM_INIT_FLAG;

	printfdbgoutfunc;

    return ret;
}
unsigned int disMemPoolDeinit()
{

	printfdbgfunc;

    g_disMemPool.initFlag = 0;
    mem_region_deinit(&g_disMemPool.stMemRegion);
    SmDelete(&(g_disMemPool.mutex));

	printfdbgoutfunc;
    return 0;
}

void  *disMemAlloc(size_t size)
{
    void * temp = NULL;
    MemMgtRegion *pRegionInfo = &g_disMemPool;
    unsigned int OutSize = 0;

    printfdbgfunc;

    if(MEM_INIT_FLAG != pRegionInfo->initFlag)
    {
        return NULL;
    }

    SmP(&(pRegionInfo->mutex), 0);
    //temp = core_malloc(&(pRegionInfo->stMemRegion), size, &OutSize);
    temp = malloc(size);
    SmV(&(pRegionInfo->mutex));

    memset(temp, 0, size);

    printfdbgoutfunc;
    return temp;
}

void  disMemFree(void *memPtr)
{
    unsigned int ret;
    MemMgtRegion *pRegionInfo = &g_disMemPool;

	printfdbgfunc;

    if(MEM_INIT_FLAG != pRegionInfo->initFlag)
    {
        return ;
    }

    SmP(&(pRegionInfo->mutex), 0);
    //ret = core_free(&(pRegionInfo->stMemRegion), memPtr);
    free(memPtr);
    SmV(&(pRegionInfo->mutex));

	printfdbgoutfunc;

    return ;
}


void disMemGetRegionInfo()
{
    unsigned int loop = 0;
    MEM_REGION *regionInfo = &g_disMemPool.stMemRegion;
    printf("******************start show the detail of region**************\r\n");
    printf("the total type is %d, %d\r\n",regionInfo->type_count, regionInfo->mem_use_info.block_type);
    for(loop = 0; loop < regionInfo->type_count; loop++)
    {
        printf("The type:%d size: %d, total blk: %d, free blk: %d, the used blk: %d\r\n", loop, regionInfo->mem_elmnt_info_p[loop].blk_size,regionInfo->mem_elmnt_info_p[loop].max_blk_num, regionInfo->mem_elmnt_info_p[loop].free_blk_num, regionInfo->mem_elmnt_info_p[loop].max_used_num);
        printf("the user info is type: %d, size: %d, MaxNum: %d, FreeNum: %d\r\n", loop, regionInfo->mem_use_info.block_info[loop].block_size, regionInfo->mem_use_info.block_info[loop].max_blk_num, regionInfo->mem_use_info.block_info[loop].free_blk_num);
    }
}