#include "stdio.h"
#include "stdarg.h"
#include <time.h>
#include "log.h"
#include "disosadapt.h"

DISLogLevel g_logLevel = DISLogLevelError;
FILE *g_logFile = NULL;

int setLogLevel(DISLogLevel logLevel)
{
    g_logLevel = logLevel;
    return 0;
}

int setLogFile(FILE *logFile)
{
    if(NULL != logFile)
    {
        g_logFile = logFile;
        return 0;
    }
    return 1;
}

#if 0
void logPrint
(
    int level, 
    const char *pszFormat, ...
)
{
    int len = 0;
    va_list pszArgp;
    char acMsg[MAX_LOG_SIZE] = {0};
    if (NULL == pszFormat)
    {
        return;
    }
    if(level > g_logLevel)
    {
        return ;
    }

    va_start(pszArgp, pszFormat);
    
    len = vsnprintf(acMsg, MAX_LOG_SIZE - 2, pszFormat, pszArgp);
    va_end(pszArgp);

    acMsg[len++] = '\n';
    acMsg[len] = '\0';

    if(NULL != g_logFile)
    {
        fputs(acMsg, g_logFile);
        fflush(g_logFile);
    }

    return ;
}
#endif

void logPrintOutPut
(
    int level, 
    int line,
    const char *function,
    const char *pszFormat, ...
)
{
    int len = 0;
	time_t lt =time(NULL);
    va_list pszArgp;
    char acMsg[MAX_LOG_SIZE+2] = {0};
    if (NULL == pszFormat)
    {
        return;
    }
    if(level > g_logLevel)
    {
        return ;
    }

	len = snprintf_s(acMsg, MAX_LOG_SIZE, "[%d]:[%s: %d]", lt,function, line);

    va_start(pszArgp, pszFormat);
    
    len += vsnprintf(acMsg + len, MAX_LOG_SIZE - len, pszFormat, pszArgp);
    va_end(pszArgp);

    acMsg[len++] = '\n';
    acMsg[len] = '\0';

    if(NULL != g_logFile)
    {
        fputs(acMsg, g_logFile);
        fflush(g_logFile);
    }

    return ;
}