#ifndef _DIS_LOG_H_
#define _DIS_LOG_H_

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#define MAX_LOG_SIZE 2046



typedef enum {
    DISLogLevelALL     = 0,
    DISLogLevelFatal   = 1,
    DISLogLevelError   = 2,
    DISLogLevelWarning = 3,
    DISLogLevelInfo    = 4
} DISLogLevel;

int setLogLevel(DISLogLevel logLevel);
int setLogFile(FILE *logFile);

void logPrintOutPut
(
    int level, 
    int line,
    const char *function,
    const char *pszFormat, ...
);

extern DISLogLevel g_logLevel;
extern FILE *g_logFile;

#define logPrint(level, format, ...)  if(level < g_logLevel) (logPrintOutPut(level, __LINE__, __FUNCTION__,format, ##__VA_ARGS__));


#ifdef DIS_DEBUG
#define printfdbg         printf
#define printfdbgfunc     logPrint(DISLogLevelALL, "[ENTER Function]")
#define printfdbgoutfunc  logPrint(DISLogLevelALL, "[EXIT Function]")
#else
#define printfdbg
#define printfdbgfunc
#define printfdbgoutfunc
#endif

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#endif /* _DIS_OS_ADAPT_H_ */