#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include "math.h"
#include "cJSON.h"
#include "dismemmgt.h"
#include "disosadapt.h"
#include "util.h"
#include "dis.h"
#include "disbodyencode.h"
#include "disrequest.h"
#include "disauth.h"
#include "discommon.h"
#include "log.h"


#define MAX_TEST_BLK  128
#define MAX_THREAD_NUM  10



char *pJsonString = "{ \
  \"records\": [\
    {\
      \"partition_key\": 0,\
      \"sequence_number\": 21,\
      \"data\": \"MTExMTExMTExMTExMTExMTExMTExMTExMTExMTExMTEx\"\
    },\
    {\
      \"partition_key\": 1,\
      \"sequence_number\": 22,\
      \"data\": \"ABxkdfakjadsfjkadjfkaldjfajfakalkjajaasdfkljaek\"\
    },\
    {\
      \"partition_key\": 2,\
      \"sequence_number\": 23,\
      \"data\": \"kjhdfahjasdhfuiawehfuihawufhawecnaefhaweifhjaofij\"\
    }\
  ],\
  \"next_partition_cursor\": \"eyJpdGVyR2VuVGltZSI6MTQ5MDk1MDE1Nzc0NywiU3RyZWFtTmFtZSI6IjY2MCIsIlNoYXJkSWQiOiIwIiwiU2hhcmRJdGVyYXRvclR5cGUiOiJBVF9TRVFVRU5DRV9OVU1CRVIiLCJTdGFydGluZ1NlcXVlbmNlTnVtYmVyIjoiMjIiLCJUaW1lU3RhbXAiOjB9\"\
}";

DISStatus GetUserAuthInfo(char *ProjectId, char *akArray, char *skArray, char *xSecurityToken)
{
    char *ak = "YOUR_AK";
    char *sk = "YOUR_SK";

    char *tempak = NULL;
    char *tempsk = NULL;

    printfdbgfunc;

    strncpy(akArray, ak, strlen(ak));
    strncpy(skArray, sk, strlen(sk));

    printfdbgoutfunc;

    return 0;
}

DISStatus PutRecordCallBack(char *errorCode, char *errorDetails, char *streamName, DISPutRecord *putRecord, char *SeqNumber, char *partitiodId)
{
    if(NULL != SeqNumber)
    {
        printf("Send Record:%s. key: %s success, the seqnum:%s, pid:%s\r\n", putRecord->recordData.data, putRecord->partitionKey, SeqNumber, partitiodId);
    }
    else
    {
        printf("Send Record:%s. key: %s fail, the errCode:%s, message:%s\r\n", putRecord->recordData.data, putRecord->partitionKey, errorCode, errorDetails);
    }

    return 0;
}

DISStatus GetRecordCallBack(char *streamName, const DISGetRecords *record)
{
    if(NULL == streamName || NULL == record || NULL == record->seqNumber || NULL == record->partitionId)
    {
        printf("%s the input param invalid\r\n", __FUNCTION__);
        return 0;
    }

    printf("the partition key is %s\r\n", record->partitionId);
    printf("the seqNumber is %s\r\n", record->seqNumber);
    printf("the data is %d: %s\r\n", record->data.stringLen, record->data.data);
    return 0;
}

char* genRandomString(int length, char *strAddr)  
{  
    int flag, i;  
    char* string = strAddr;  
      
    if(NULL == strAddr)
    {
        return NULL;
    }
  
    for (i = 0; i < length - 1; i++)  
    {  
        flag = rand() % 3;  
        switch (flag)  
        {  
            case 0:  
                string[i] = 'A' + rand() % 26;  
                break;  
            case 1:  
                string[i] = 'a' + rand() % 26;  
                break;  
            case 2:  
                string[i] = '0' + rand() % 10;  
                break;  
            default:  
                string[i] = 'x';  
                break;  
        }  
    }  
    string[length - 1] = '\0';  
    return string;  
}  

void testMalloc()
{
	int loop = 1;
	void *ptr[10000] = {0};
	void *tempPtr = 0;
	int len = 0;

	printf("start test malloc\r\n");

	for(loop = 0; loop < 10000; loop++)
	{
		len = rand()%(1*4*1024) + 1;
		tempPtr = disMemAlloc(len);
		if(NULL == tempPtr)
		{
			printf("malloc %d size error,the loop is %d\r\n", len, loop);
		}
		ptr[loop] = tempPtr;
	}
#if 1
	for(loop = 0; loop < 10000; loop++)
	{
		tempPtr = ptr[loop];
		disMemFree(tempPtr);
		ptr[loop] = NULL;
	}
#endif
	disMemGetRegionInfo();
}

void testCommonList()
{
    DisRecordListItem *pTempItem = NULL;
    DISPutRecord record[10] = {0};
    int loop=0;
    int len = 0;
    int ret = 0;
    DisRecordList *tempList = NULL;
    char MsgBuffer[1024] = {0};
    char MsgKey[32] = {0};

    ret = DisRecordListInit(11, &tempList);
    if(0 != ret)
    {
        printf("list init error: %d\r\n", ret);
        return ;
    }

    for(loop = 0; loop < 10; loop++)
    {
        len = rand() % 1024;
        record[loop].partitionKey = genRandomString(20,MsgKey);
        record[loop].recordData.data = genRandomString(len, MsgBuffer);
        record[loop].recordData.stringLen = len;        
    }

    for(loop = 0; loop < 10; loop++)
    {
        pTempItem = DisRecordListItemAlloc(&record[loop]);
        if(NULL == pTempItem)
        {
            printf("alloc err: %d\r\n", loop);
            return;
        }

        if(loop%2)
        {
            ret = DisRecordListInsertToTail(tempList, pTempItem);
            if(0 != ret)
            {
                printf("InsertToTail %d count fail: %d\r\n", loop, ret);
                return;
            }
        }
        else
        {
            ret = DisRecordListInsertToHead(tempList, pTempItem);
            if(0 != ret)
            {
                printf("InsertToHead %d count fail: %d\r\n", loop, ret);
                return;
            }
        }
    }

    DisListDebug(tempList);

    loop = 0;
    while(1)
    {
        pTempItem = DisRecordListGetNode(tempList);
        if(NULL != pTempItem)
        {
            printf("the %d record data: %s, partitionKey: %s\r\n", loop, pTempItem->RawData.data, pTempItem->partitionKey);
            DisRecordListItemRelease(pTempItem);
            loop++;
        }
        else
        {
            printf("the list is empty, count is %d\r\n", loop);
            break;
        }
    }
    
    DisRecordListDeinit(tempList);

}

void testListStream()
{
    char *ak = "YOUR_AK";
    char *sk = "YOUR_SK";
    char *projectId = "YOUR_PROJECT_ID";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com";
    int ret = 0;
    DISResponseInfo RspInfo = {0};

    DISListStream listStream = {0};

    ret = ListStream(host, projectId, region, &listStream, &RspInfo);
    if(ret != 0)
    {
        printf("List Error: %d\r\n", ret);
    }

    printf("the totalcount is %d, the current count is %d\r\n", listStream.streamListResult.totalNumber, listStream.streamListResult.currentNumber);

    return;
}

#define MAX_RECORD_SEND   5000

void testSendRequest()
{
    char *projectId = "c159a24641da49b2a729ea6f57647888";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com:20004";
    int ret = 0;
    DISPutRecord putRecord = {0};
    char MsgBuffer[1024] = {0};
    char MsgKey[32] = {0};
    int len = 0;
    int loop = 0;
    int count = 0;
    char *streamName = NULL;

    for(loop = 0; loop < MAX_RECORD_SEND; loop ++)
    {
        len = rand() % 1023;
        putRecord.recordData.data = genRandomString(len, MsgBuffer);
        putRecord.recordData.stringLen = len;
        putRecord.partitionKey = genRandomString(31, MsgKey);

        count = rand()%5;
        switch(count % 5)
        {
        case 0:
            streamName = "wl_test";
            break;

        case 1:
            streamName = "xxxxx_test";
            break;

        case 2:
            streamName = "yyyyy_test";
            break;

        case 3:
            streamName = "zzzzz_test";
            break;

        default:
            streamName = "ooooo_test";
            break;

        }

        ret = PutRecordsAsyn(host, projectId, region, streamName, &putRecord, PutRecordCallBack);
        if(0 != ret)
        {
            printf("send %d msg err: %d\r\n", loop, ret);
        }
    }

    DisHashTableDbgInfo();
    
    return;
}

void testGetCursor()
{
    char *ak = "YOUR_AK";
    char *sk = "YOUR_SK";
    char *projectId = "YOUR_PROJECT_ID";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com";
    int ret = 0;
    DISResponseInfo RspInfo = {0};

    DISGetCursor     tempCursor = {0};
    tempCursor.streamName = "wl-test";
    tempCursor.partitionId = "0";
    tempCursor.cursorType = DISCursorTypeAtSeqNumber;
    tempCursor.startingSequenceNumber = "0";

    ret = DisGetCursor(host, projectId, region, &tempCursor, &RspInfo);
    if(ret != 0)
    {
        printf("GetCursor Error: %d\r\n", ret);
    }

    printf("the rsp code is %d\r\n", RspInfo.HttpResponseCode);

    if(RspInfo.HttpResponseCode >= 300 || RspInfo.HttpResponseCode < 200)
    {
        printf("the errorCode is %s, message is %s\r\n", RspInfo.ErrorCode, RspInfo.ErrorDetail);
    }
    else
    {
        printf("the partition cursor is %s\r\n", tempCursor.cursorResult.partitionCursor);
    }

    return;
}

void testGetRecord()
{
    char *ak = "YOUR_AK";
    char *sk = "YOUR_SK";
    char *projectId = "YOUR_PROJECT_ID";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com";
    int ret = 0;
    DISResponseInfo RspInfo = {0};
    DISCursor  NestCursor = {0};

    DISGetCursor     tempCursor = {0};
    tempCursor.streamName = "wl-test";
    tempCursor.partitionId = "0";
    tempCursor.cursorType = DISCursorTypeAtSeqNumber;
    tempCursor.startingSequenceNumber = "0";

    ret = DisGetCursor(host, projectId, region, &tempCursor, &RspInfo);
    if(ret != 0 || RspInfo.HttpResponseCode >= 300)
    {
        printf("GetCursor Error: %d, the http code id %d, Error Code :%s, message: %s\r\n", ret, RspInfo.HttpResponseCode, RspInfo.ErrorCode, RspInfo.ErrorDetail);
        return;
    }

    RspInfo.HttpResponseCode = 0;
    ret = GetRecords(host, projectId, region, tempCursor.streamName, tempCursor.cursorResult.partitionCursor, 0, &NestCursor, GetRecordCallBack, &RspInfo);
    if(ret != 0 || RspInfo.HttpResponseCode >= 300)
    {
        printf("GetCursor Error: %d, the http code id %d, Error Code :%s, message: %s\r\n", ret, RspInfo.HttpResponseCode, RspInfo.ErrorCode, RspInfo.ErrorDetail);
        return;
    }
}

void testSendRecord()
{
    char *ak = "YOUR_AK";
    char *sk = "YOUR_SK";
    char *projectId = "YOUR_PROJECT_ID";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com";
    int ret = 0;
    DISResponseInfo RspInfo = {0};
    int Count = 0;

    char *streamName = "wl-test";

    DISPutRecord Record[5] = {0};

    char msg1[1024]  ={0};
    char msg2[1024]  ={0};
    char msg3[1024]  ={0};
    char msg4[1024]  ={0};
    char msg5[1024]  ={0};
    int len = 0;

    char msg[4096] = {0};

    Record[0].recordData.stringLen = strlen("aaaaaaaaaa");
    Record[0].recordData.data = "aaaaaaaaaa";
    Record[0].partitionKey = "1";

    Record[1].recordData.stringLen = rand()%1023 + 1;
    Record[1].recordData.data = genRandomString(Record[1].recordData.stringLen, msg2);
    Record[1].partitionKey = "1";

    Record[2].recordData.stringLen = rand()%1023 + 1;
    Record[2].recordData.data = genRandomString(Record[2].recordData.stringLen, msg3);
    Record[2].partitionKey = "2";

    //DisBodyEncodeRecords(streamName, Record, 3, msg, &len, 4096);
    
    ret = PutRecords(host, projectId, region, streamName, 1, Record, PutRecordCallBack, &RspInfo);
    if(ret != 0 || RspInfo.HttpResponseCode >= 300)
    {
        printf("Send Record Faiure, the httprspcode is %d. ret: %d\r\n", RspInfo.HttpResponseCode, ret);
    }


    return;
}

int main()
{
    int ret = 0;
    FILE *logFile = NULL;

    char *ak = "YOUR_AK";
    char *sk = "YOUR_SK";
    char *projectId = "YOUR_PROJECT_ID";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com";

    srand((unsigned) time(NULL ));

    
    logFile = fopen("log.txt", "a+");
    if(NULL == logFile)
    {
        printf("open file error\r\n");
        return 1;
    }
    printf("step 1\r\n");
    ret = DisInit(logFile, GetUserAuthInfo);
    if(0 != ret)
    {
        printf("init error: %d\r\n", ret);
        getchar();
        return ret;
    }

	printf("start test\r\n");

	logPrint(1, "this is a test: %d", ret);

    //testCommonList();
    //testListStream();
    //testSendRequest();
    //testGetCursor();   
    //testGetRecord();
    //testSendRecord();
	testMalloc();

#if 0
    ctx = DisCtxCreate(ak, sk, projectId, host, region);
    printf("step 2\r\n");
    descirbeInfo.streamName = "stream_test";
    descirbeInfo.startPartitionId = "shardId-0000000000";
    descirbeInfo.limitPartitionNum = 1;

    deleteStream.streamName = "wl_test";
    printf("step 3\r\n");
    //ret = DescribeStream(&stContext, &descirbeInfo);

    //ret = CreateStream(&stContext, &streamInfo);

    //ret = DeleteStream(&stContext, "wl_test");

    //ret = ListStream(ctx, &listStream);

#endif
    printf("hello world\r\n");
    getchar();
    disMemGetRegionInfo();
    getchar();
    DisDeinit();


    return 0;
}

