#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include "math.h"
#include "string.h"
#include "stdbool.h"
//#include "cJSON.h"
//#include "dismemmgt.h"
//#include "disosadapt.h"
//#include "util.h"
#include "dis.h"
//#include "disbodyencode.h"
//#include "disrequest.h"
//#include "disauth.h"
//#include "discommon.h"
#include "log.h"

#define MAX_TEST_BLK  128
#define MAX_THREAD_NUM  10

DISStatus GetUserAuthInfo(char *ProjectId, char *akArray, char *skArray, char *xSecurityToken)
{
	char *ak = "YOUR_AK";
	char *sk = "YOUR_SK";

    printfdbgfunc;

    strncpy(akArray, ak, strlen(ak));
    strncpy(skArray, sk, strlen(sk));

    printfdbgoutfunc;

    return 0;
}

DISStatus GetDISPropertyFilePath(char *pucDISPropertyFilePath)
{
    printfdbgfunc;
    
    if(DISPROPERTIESFILEPATH && strlen(DISPROPERTIESFILEPATH))
    {
        strncpy(pucDISPropertyFilePath,DISPROPERTIESFILEPATH,strlen(DISPROPERTIESFILEPATH));
    }
    
    printfdbgoutfunc;

    return 0;
}


DISStatus PutRecordCallBack(char *errorCode, char *errorDetails, char *streamName, DISPutRecord *putRecord, char *SeqNumber, char *partitiodId)
{
    if(NULL != SeqNumber)
    {
        printf("Send Record:%s. key: %s success, the seqnum:%s, pid:%s\r\n", putRecord->recordData.data, putRecord->partitionKey, SeqNumber, partitiodId);
    }
    else
    {
        printf("Send Record:%s. key: %s fail, the errCode:%s, message:%s\r\n", putRecord->recordData.data, putRecord->partitionKey, errorCode, errorDetails);
    }

    return 0;
}

DISStatus GetRecordCallBack(char *streamName, const DISGetRecords *record)
{
    if(NULL == streamName || NULL == record || NULL == record->seqNumber || NULL == record->partitionId)
    {
        printf("%s the input param invalid\r\n", __FUNCTION__);
        return 0;
    }

	printf("the partition key is %s\r\n", record->partitionId);
	printf("the seqNumber is %s\r\n", record->seqNumber);
	printf("the data is %d: %s\r\n", record->data.stringLen, record->data.data);
	printf("the timestamp_type is %s: %ld\r\n", record->timestampType, record->timestamp);
	return 0;
}

char* genRandomString(int length, char *strAddr)  
{  
    int flag, i;  
    char* string = strAddr;  
      
    if(NULL == strAddr)
    {
        return NULL;
    }
  
    for (i = 0; i < length - 1; i++)  
    {  
        flag = rand() % 3;  
        switch (flag)  
        {  
            case 0:  
                string[i] = 'A' + rand() % 26;  
                break;  
            case 1:  
                string[i] = 'a' + rand() % 26;  
                break;  
            case 2:  
                string[i] = '0' + rand() % 10;  
                break;  
            default:  
                string[i] = 'x';  
                break;  
        }  
    }  
    string[length - 1] = '\0';  
    return string;  
}  

char* genRandomStringWithoutNull(int length, char *strAddr)
{
	int flag, i;
	char* string = strAddr;

	if (NULL == strAddr)
	{
		return NULL;
	}

	for (i = 0; i < length; i++)
	{
		flag = rand() % 3;
		switch (flag)
		{
		case 0:
			string[i] = 'A' + rand() % 26;
			break;
		case 1:
			string[i] = 'a' + rand() % 26;
			break;
		case 2:
			string[i] = '0' + rand() % 10;
			break;
		default:
			string[i] = 'x';
			break;
		}
	}
	return string;
}

void testMalloc()
{
	int loop = 1;
	void *ptr[10000] = {0};
	void *tempPtr = 0;
	int len = 0;

	printf("start test malloc\r\n");

	for(loop = 0; loop < 10000; loop++)
	{
		len = rand()%(1*4*1024) + 1;
		tempPtr = disMemAlloc(len);
		if(NULL == tempPtr)
		{
			printf("malloc %d size error,the loop is %d\r\n", len, loop);
		}
		ptr[loop] = tempPtr;
	}
#if 1
	for(loop = 0; loop < 10000; loop++)
	{
		tempPtr = ptr[loop];
		disMemFree(tempPtr);
		ptr[loop] = NULL;
	}
#endif
	disMemGetRegionInfo();
}
#if 0
void testCommonList()
{
    DisRecordListItem *pTempItem = NULL;
    DISPutRecord record[10] = {0};
    int loop=0;
    int len = 0;
    int ret = 0;
    DisRecordList *tempList = NULL;
    char MsgBuffer[1024] = {0};
    char MsgKey[32] = {0};

    ret = DisRecordListInit(11, &tempList);
    if(0 != ret)
    {
        printf("list init error: %d\r\n", ret);
        return ;
    }

    for(loop = 0; loop < 10; loop++)
    {
        len = rand() % 1024;
        record[loop].partitionKey = genRandomString(20,MsgKey);
        record[loop].recordData.data = genRandomString(len, MsgBuffer);
        record[loop].recordData.stringLen = len;        
    }

    for(loop = 0; loop < 10; loop++)
    {
        pTempItem = DisRecordListItemAlloc(&record[loop]);
        if(NULL == pTempItem)
        {
            printf("alloc err: %d\r\n", loop);
            return;
        }

        if(loop%2)
        {
            ret = DisRecordListInsertToTail(tempList, pTempItem);
            if(0 != ret)
            {
                printf("InsertToTail %d count fail: %d\r\n", loop, ret);
                return;
            }
        }
        else
        {
            ret = DisRecordListInsertToHead(tempList, pTempItem);
            if(0 != ret)
            {
                printf("InsertToHead %d count fail: %d\r\n", loop, ret);
                return;
            }
        }
    }

    DisListDebug(tempList);

    loop = 0;
    while(1)
    {
        pTempItem = DisRecordListGetNode(tempList);
        if(NULL != pTempItem)
        {
            printf("the %d record data: %s, partitionKey: %s\r\n", loop, pTempItem->RawData.data, pTempItem->partitionKey);
            DisRecordListItemRelease(pTempItem);
            loop++;
        }
        else
        {
            printf("the list is empty, count is %d\r\n", loop);
            break;
        }
    }
    
    DisRecordListDeinit(tempList);

}
#endif

void testDeleteStream(char *streamName,char *host,char *projectId,char *region)
{
    int ret = 0;
    DISResponseInfo RspInfo = {0};
    
    printf("===================%s Begin=======================\n",__FUNCTION__);
    ret = DeleteStream(host, projectId, region, streamName, &RspInfo);
    if(ret != 0)
    {
        printf("Delete Error: %d\r\n", ret);
        printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
        printf("ErrorCode: %s\r\n", RspInfo.ErrorCode);
        printf("ErrorDetail: %s\r\n", RspInfo.ErrorDetail);
    }
    else
    {
        printf("Delete stream %s success\r\n",streamName);
        printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
    }
    printf("===================%s End=======================\n",__FUNCTION__);
    return ;
}


void testCreateStream(char *pucStreamName, char *host, char *projectId, char *region, bool isCommomStream)
{
	int ret = 0;
	DISResponseInfo RspInfo = { 0 };
	DISCreateStream *pstCreateStream = disMemAlloc(sizeof(DISCreateStream));
	DISCreateStreamExpend *pstCreateStreamExpend = disMemAlloc(sizeof(DISCreateStreamExpend));
	
	if (isCommomStream)
	{		
		pstCreateStreamExpend->dataType = DISDataTypeBlob;
		pstCreateStreamExpend->dataDuration = 2 * 24;
	}
	else
	{
		ObsDestinationDescriptor *pstObsDestinationDescriptor = disMemAlloc(sizeof(ObsDestinationDescriptor));
		pstObsDestinationDescriptor->agencyName = "all";
		pstObsDestinationDescriptor->obsBucketPath = "obs-shawn";

		pstCreateStreamExpend->dataType = DISDataTypeFile;
		pstCreateStreamExpend->dataDuration = 3 * 24;
		pstCreateStreamExpend->obsDestinationDescriptor = *pstObsDestinationDescriptor;
	}

	pstCreateStream->partitionCount = 2;
	pstCreateStream->streamName = pucStreamName;
	pstCreateStream->streamType = DISStreamTypeAdvanced;
	pstCreateStream->pucReserved = pstCreateStreamExpend;

	printf("===================%s Begin=======================\n", __FUNCTION__);
	ret = CreateStream(host, projectId, region, pstCreateStream, &RspInfo);
	if (ret != 0)
	{
		printf("Create Error: %d\r\n", ret);
		printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
		printf("ErrorCode: %s\r\n", RspInfo.ErrorCode);
		printf("ErrorDetail: %s\r\n", RspInfo.ErrorDetail);
	}
	else
	{
		printf("Create stream %s success\n", pstCreateStream->streamName);
		printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
	}

	disMemFree(pstCreateStream);
	printf("===================%s End=======================\n", __FUNCTION__);
	return;
}


void testListStream(char *host,char *projectId,char *region)
{
    int ret = 0;
   	int i = 0;
    DISResponseInfo RspInfo = {0};

    DISListStream listStream = {0};
    listStream.limit = 2;
    listStream.startStreamName = "dis-shawn";

    printf("===================%s Begin=======================\n",__FUNCTION__);
    ret = ListStream(host, projectId, region, &listStream, &RspInfo);
    if(ret != 0)
    {
        printf("List Error: %d\r\n", ret);
        printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
        printf("ErrorCode: %s\r\n", RspInfo.ErrorCode);
        printf("ErrorDetail: %s\r\n", RspInfo.ErrorDetail);
        return;
    }

	printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
	printf("the totalcount is %d, the current count is %d\r\n", listStream.streamListResult.totalNumber, listStream.streamListResult.currentNumber);
	printf("hasMoreStream: %ld\r\n", listStream.streamListResult.hasMoreStream);
	printf("streamList include: ");
	for (i = 0; i < listStream.streamListResult.currentNumber; i++)
	{
		printf("%s, ", listStream.streamListResult.streamList[i].streamName);
	}
	printf("\b\b \r\n");
	printf("===================%s End=======================\n", __FUNCTION__);
	return;
}

void testDescribeStream(char *streamName, char *host, char *projectId, char *region)
{
	int ret = 0;
	int i = 0;
	DISResponseInfo RspInfo = { 0 };

	DISDescribeStream streamDetail = { 0 };
	streamDetail.streamName = streamName;
	//streamDetail.startPartitionId="";
	//streamDetail.limitPartitionNum=10;
	printf("===================%s Begin=======================\n", __FUNCTION__);
	ret = DescribeStream(host, projectId, region, &streamDetail, &RspInfo);
	if (ret != 0)
	{
		printf("List Error: %d\r\n", ret);
		printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
		printf("ErrorCode: %s\r\n", RspInfo.ErrorCode);
		printf("ErrorDetail: %s\r\n", RspInfo.ErrorDetail);
		return;
	}

	printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
	printf("streamId:%s\n", streamDetail.streamInfo.streamId);
	printf("streamName:%s\n", streamDetail.streamInfo.streamName);
	printf("createTime:%ld\n", streamDetail.streamInfo.createTime);
	printf("lastModifyTime:%ld\n", streamDetail.streamInfo.lastModifyTime);
	printf("retentionPeriod:%ld\n", streamDetail.streamInfo.retentionPeriod);
	printf("dataType:%s\n", streamDetail.streamInfo.dataType == DISDataTypeBlob ? "BLOB"
		: (streamDetail.streamInfo.dataType == DISDataTypeJson) ? "JSON"
		: (streamDetail.streamInfo.dataType == DISDataTypeCsv) ? "CSV"
		: "FILE");
	printf("streamStatus:%s\n", streamDetail.streamInfo.streamStatus == DISStreamStatusCreating ? "CREATING"
		: (streamDetail.streamInfo.streamStatus == DISStreamStatusRunning) ? "RUNNING"
		: (streamDetail.streamInfo.streamStatus == DISStreamStatusTerminating) ? "TERMINATING"
		: "FROZEN");
	printf("streamType:%s\n", streamDetail.streamInfo.streamType == DISStreamTypeCommon ? "Common" : "Advanced");
	printf("hasMorepartition:%s\n", streamDetail.streamInfo.hasMorepartition == 0 ? "false" : "true");
	printf("currentNumber:%ld\n", streamDetail.streamInfo.currentNumber);
	for (i = 0; i < streamDetail.streamInfo.currentNumber; i++)
	{
		printf("loop %d partitionStatus:%s\n", i, streamDetail.streamInfo.partitionList[i].partitionStatus == DISPartitionStatusCreating ? "CREATING"
			: (streamDetail.streamInfo.partitionList[i].partitionStatus == DISPartitionStatusActive) ? "ACTIVE"
			: (streamDetail.streamInfo.partitionList[i].partitionStatus == DISPartitionStatusDeleted) ? "DELETED"
			: "EXPIRED");
		printf("loop %d partitionId:%s\n", i, streamDetail.streamInfo.partitionList[i].partitionId);
		printf("loop %d hashRange:%s\n", i, streamDetail.streamInfo.partitionList[i].hashRange);
		printf("loop %d sequenceNumberRange:%s\n", i, streamDetail.streamInfo.partitionList[i].sequenceNumberRange);
	}
	printf("===================%s End=======================\n", __FUNCTION__);
	return;
}

#define MAX_RECORD_SEND   5000

void testSendRequest()
{
    char *projectId = "c159a24641da49b2a729ea6f57647888";
    char *region = "cn-north-1";
    char *service = "dis";
    char *host = "dis.cn-north-1.myhuaweicloud.com:20004";
    int ret = 0;
    DISPutRecord putRecord = {0};
    char MsgBuffer[1024] = {0};
    char MsgKey[32] = {0};
    int len = 0;
    int loop = 0;
    int count = 0;
    char *streamName = NULL;
    printf("===================%s Begin=======================\n",__FUNCTION__);
    for(loop = 0; loop < MAX_RECORD_SEND; loop ++)
    {
        len = rand() % 1023;
        putRecord.recordData.data = genRandomString(len, MsgBuffer);
        putRecord.recordData.stringLen = len;
        putRecord.partitionKey = genRandomString(31, MsgKey);

        count = rand()%5;
        switch(count % 5)
        {
        case 0:
            streamName = "wl_test";
            break;

        case 1:
            streamName = "xxxxx_test";
            break;

        case 2:
            streamName = "yyyyy_test";
            break;

        case 3:
            streamName = "zzzzz_test";
            break;

        default:
            streamName = "ooooo_test";
            break;

        }

        ret = PutRecordsAsyn(host, projectId, region, streamName, &putRecord, PutRecordCallBack);
        if(0 != ret)
        {
            printf("send %d msg err: %d\r\n", loop, ret);
        }
    }

    DisHashTableDbgInfo();
    printf("===================%s End=======================\n",__FUNCTION__);
    return;
}

void testGetCursor(char *streamName, char *host, char *projectId, char *region)
{
    int ret = 0;
    DISResponseInfo RspInfo = {0};

    DISGetCursor     tempCursor = {0};
    tempCursor.streamName = streamName;
    tempCursor.partitionId = "0";
    tempCursor.cursorType = DISCursorTypeAtSeqNumber;
    tempCursor.startingSequenceNumber = "0";
	//tempCursor.cursorType = DISCursorTypeAtTimestamp;
	//tempCursor.timestamp = "1536026725191";
	
	printf("===================%s Begin=======================\n", __FUNCTION__);
    ret = DisGetCursor(host, projectId, region, &tempCursor, &RspInfo);
    if(ret != 0)
    {
        printf("GetCursor Error: %d\r\n", ret);
    }

    printf("the rsp code is %d\r\n", RspInfo.HttpResponseCode);

    if(RspInfo.HttpResponseCode >= 300 || RspInfo.HttpResponseCode < 200)
    {
		printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
        printf("the errorCode is %s, message is %s\r\n", RspInfo.ErrorCode, RspInfo.ErrorDetail);
		printf("===================%s End=======================\n", __FUNCTION__);
    }
    else
    {
		printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
        printf("the partition cursor is %s\r\n", tempCursor.cursorResult.partitionCursor);
		printf("===================%s End=======================\n", __FUNCTION__);
    }

    return;
}

void testGetRecord(char *streamName,char *host,char *projectId,char *region)
{
    int ret = 0;
    DISResponseInfo RspInfo = {0};
    DISCursor  NestCursor = {0};
    printf("===================%s Begin=======================\n",__FUNCTION__);
    DISGetCursor     tempCursor = {0};
    tempCursor.streamName = streamName;
    tempCursor.partitionId = "shardId-0000000000";
    tempCursor.cursorType = DISCursorTypeAtSeqNumber;
    tempCursor.startingSequenceNumber = "0";

    ret = DisGetCursor(host, projectId, region, &tempCursor, &RspInfo);
    if(ret != 0 || RspInfo.HttpResponseCode >= 300)
    {
        printf("GetCursor Error: %d, the http code id %d, Error Code :%s, message: %s\r\n", ret, RspInfo.HttpResponseCode, RspInfo.ErrorCode, RspInfo.ErrorDetail);
        printf("===================%s End=======================\n",__FUNCTION__);
        return;
    }
	printf("===================Got Cursor=======================\n");
    RspInfo.HttpResponseCode = 0;
    ret = GetRecords(host, projectId, region, tempCursor.streamName, tempCursor.cursorResult.partitionCursor, 0, &NestCursor, GetRecordCallBack, &RspInfo);
    if(ret != 0 || RspInfo.HttpResponseCode >= 300)
    {
        printf("GetRecords Error: %d, the http code id %d, Error Code :%s, message: %s\r\n", ret, RspInfo.HttpResponseCode, RspInfo.ErrorCode, RspInfo.ErrorDetail);
        printf("===================%s Begin=======================\n",__FUNCTION__);
        return;
    }
}


#define MAX_RECORD_COUNT   500
#define MAX_RECORD_LEN   (1024*10)

void testSendRecord(char*streamName,char *host,char *projectId,char *region)
{    
    int ret = 0;
    DISResponseInfo RspInfo = {0};
    int serrializedMode = DISGetSerializedMode();
    DISPutRecord Record[MAX_RECORD_COUNT] = {0};

	int i = 0;
	int count = MAX_RECORD_COUNT;
	int len = MAX_RECORD_LEN;
	char *pmsg[MAX_RECORD_COUNT];

	printf("===================%s Begin=======================\n", __FUNCTION__);
	if (GetProtobufMode() == serrializedMode)
	{
		for (i = 0; i < count; i++)
		{
			Record[i].recordData.stringLen = rand() % len;
			pmsg[i] = malloc(Record[i].recordData.stringLen);
			Record[i].recordData.data = genRandomStringWithoutNull(Record[i].recordData.stringLen, pmsg[i]);
			Record[i].partitionKey = "2";
		}
	}
	else if (GetBase64Mode() == serrializedMode)
	{
		for (i = 0; i < count; i++)
		{
			Record[i].recordData.stringLen = rand() % len;
			pmsg[i] = malloc(Record[i].recordData.stringLen);
			Record[i].recordData.data = genRandomString(Record[i].recordData.stringLen, pmsg[i]);
			Record[i].partitionKey = "2";
		}
	}
	printf("inputrecord:%s\n", Record[0].recordData.data);
	//printf("inputrecord:%s\n", Record[1].recordData.data);
	//printf("inputrecord:%s\n", Record[2].recordData.data);

    ret = PutRecords(host, projectId, region, streamName, count, Record, PutRecordCallBack, &RspInfo);
    if(ret != 0 || RspInfo.HttpResponseCode >= 300)
    {
        printf("Send Record Faiure, the httprspcode is %d. ret: %d\r\n", RspInfo.HttpResponseCode, ret);
        printf("ErrorCode: %s\r\n", RspInfo.ErrorCode);
        printf("ErrorDetail: %s\r\n", RspInfo.ErrorDetail);
    }
    else
    {
        printf("send Record Success,ret:%d\n",RspInfo.HttpResponseCode);
        printf("HttpResponseCode: %ld\r\n", RspInfo.HttpResponseCode);
    }
	for (i = 0; i < count; i++)
	{
		free(pmsg[i]);
	}
    printf("===================%s End=======================\n",__FUNCTION__);
    return;
}

int main()
{
    int ret = 0;
    FILE *logFile = NULL;

    char *projectId = "43eec61d4b514f359c97008a4f8bfb02";
    char *region = "southchina";
    char *host = "10.154.74.187:1445";
    
    char *streamName = "dis-shawn";
    
    srand((unsigned) time(NULL ));

    
    logFile = fopen("log.txt", "a+");
    if(NULL == logFile)
    {
        printf("open file error\r\n");
        return 1;
    }
    printf("step 1\r\n");
    ret = DisInit(logFile, GetUserAuthInfo);
    if(0 != ret)
    {
        printf("init error: %d\r\n", ret);
        getchar();
        return ret;
    }
    /*this function have not used acturelly*/
    #if 0
    ret = SetUserAuthInfo("DJZN5UEQSODCWJ7NGOMC","vRNwGMd92PlityIO3daDseoS9hciL9xKSKkBiJ44",0);
    if(DISStatusOK != ret)
    {
        printf("ak/sk config error");
        return ret ;
    }
    #endif
	printf("start test\r\n");

	logPrint(1, "this is a test: %d", ret);
	setLogLevel(5);
	//DISSetSerializedMode("protobuf");
	DISSetSerializedMode("base64");
	testMalloc();
	testDeleteStream(streamName,host,projectId,region);
	testCreateStream(streamName,host,projectId,region, true);
	testListStream(host,projectId,region);    
	testDescribeStream(streamName, host, projectId, region);
	testGetCursor(streamName,host,projectId,region);   
	testSendRecord(streamName,host,projectId,region);
	testGetRecord(streamName, host, projectId, region);
	printf("hello world\r\n");
	getchar();
	//testCommonList(streamName);
	//testSendRequest();
	//disMemGetRegionInfo();
	//getchar();
	DisDeinit();
	return 0;
}

